

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>USBQualityTest &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Module code" href="index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for USBQualityTest</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="sd">&quot;&quot;&quot;Test quality of USB connection to weather station</span>

<span class="sd">::</span>

<span class="sd">%s</span>

<span class="sd">The USB link to my weather station is not 100%% reliable. The data</span>
<span class="sd">read from the station by the computer is occasionally corrupted,</span>
<span class="sd">perhaps by interference. I&#39;ve been trying to solve this by putting</span>
<span class="sd">ferrite beads around the USB cable and relocating possible</span>
<span class="sd">interference sources such as external hard drives. All without any</span>
<span class="sd">success so far.</span>

<span class="sd">This program tests the USB connection for errors by continuously</span>
<span class="sd">reading the entire weather station memory (except for those parts that</span>
<span class="sd">may be changing) looking for errors. Each 32-byte block is read twice,</span>
<span class="sd">and if the two readings differ a warning message is displayed. Also</span>
<span class="sd">displayed are the number of blocks read, and the number of errors</span>
<span class="sd">found.</span>

<span class="sd">I typically get one or two errors per hour, so the test needs to be</span>
<span class="sd">run for several hours to produce a useful measurement. Note that other</span>
<span class="sd">software that accesses the weather station (such as :doc:`Hourly` or</span>
<span class="sd">:doc:`LiveLog`) must not be run while the test is in progress.</span>

<span class="sd">If you run this test and get no errors at all, please let me know.</span>
<span class="sd">There is something good about your setup and I&#39;d love to know what it</span>
<span class="sd">is!</span>

<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__docformat__</span> <span class="o">=</span> <span class="s">&quot;restructuredtext en&quot;</span>

<span class="n">__usage__</span> <span class="o">=</span> <span class="s">&quot;&quot;&quot;</span>
<span class="s"> usage: python USBQualityTest.py [options]</span>
<span class="s"> options are:</span>
<span class="s">  -h | --help           display this help</span>
<span class="s">  -v | --verbose        increase amount of reassuring messages</span>
<span class="s">                        (repeat for even more messages e.g. -vvv)</span>
<span class="s">&quot;&quot;&quot;</span>

<span class="n">__doc__</span> <span class="o">%=</span> <span class="n">__usage__</span>
<span class="n">__usage__</span> <span class="o">=</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">__usage__</span>

<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="kn">from</span> <span class="nn">pywws.Logger</span> <span class="kn">import</span> <span class="n">ApplicationLogger</span>
<span class="kn">from</span> <span class="nn">pywws</span> <span class="kn">import</span> <span class="n">WeatherStation</span>

<div class="viewcode-block" id="main"><a class="viewcode-back" href="../api/USBQualityTest.html#USBQualityTest.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span><span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;hv&quot;</span><span class="p">,</span> <span class="p">(</span><span class="s">&#39;help&#39;</span><span class="p">,</span> <span class="s">&#39;verbose&#39;</span><span class="p">))</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: no arguments allowed</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="c"># process options</span>
    <span class="n">verbose</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-h&#39;</span><span class="p">,</span> <span class="s">&#39;--help&#39;</span><span class="p">):</span>
            <span class="k">print</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-v&#39;</span><span class="p">,</span> <span class="s">&#39;--verbose&#39;</span><span class="p">):</span>
            <span class="n">verbose</span> <span class="o">+=</span> <span class="mi">1</span>
    <span class="c"># do it!</span>
    <span class="n">logger</span> <span class="o">=</span> <span class="n">ApplicationLogger</span><span class="p">(</span><span class="n">verbose</span><span class="p">)</span>
    <span class="n">ws</span> <span class="o">=</span> <span class="n">WeatherStation</span><span class="o">.</span><span class="n">weather_station</span><span class="p">()</span>
    <span class="n">fixed_block</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">()</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">fixed_block</span><span class="p">:</span>
        <span class="k">print</span> <span class="s">&quot;No valid data block found&quot;</span>
        <span class="k">return</span> <span class="mi">3</span>
    <span class="c"># loop</span>
    <span class="n">ptr</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">data_start</span>
    <span class="n">total_count</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">bad_count</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">while</span> <span class="bp">True</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">total_count</span> <span class="o">%</span> <span class="mi">1000</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="n">active</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">current_pos</span><span class="p">()</span>
        <span class="k">while</span> <span class="bp">True</span><span class="p">:</span>
            <span class="n">ptr</span> <span class="o">+=</span> <span class="mh">0x20</span>
            <span class="k">if</span> <span class="n">ptr</span> <span class="o">&gt;=</span> <span class="mh">0x10000</span><span class="p">:</span>
                <span class="n">ptr</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">data_start</span>
            <span class="k">if</span> <span class="n">active</span> <span class="o">&lt;</span> <span class="n">ptr</span> <span class="o">-</span> <span class="mh">0x10</span> <span class="ow">or</span> <span class="n">active</span> <span class="o">&gt;=</span> <span class="n">ptr</span> <span class="o">+</span> <span class="mh">0x20</span><span class="p">:</span>
                <span class="k">break</span>
        <span class="n">result_1</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">_read_block</span><span class="p">(</span><span class="n">ptr</span><span class="p">,</span> <span class="n">retry</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
        <span class="n">result_2</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">_read_block</span><span class="p">(</span><span class="n">ptr</span><span class="p">,</span> <span class="n">retry</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">result_1</span> <span class="o">!=</span> <span class="n">result_2</span><span class="p">:</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="s">&#39;read_block changing </span><span class="si">%06x</span><span class="s">&#39;</span><span class="p">,</span> <span class="n">ptr</span><span class="p">)</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="s">&#39;  </span><span class="si">%s</span><span class="s">&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">result_1</span><span class="p">))</span>
            <span class="n">logger</span><span class="o">.</span><span class="n">warning</span><span class="p">(</span><span class="s">&#39;  </span><span class="si">%s</span><span class="s">&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="n">result_2</span><span class="p">))</span>
            <span class="n">bad_count</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="n">total_count</span> <span class="o">+=</span> <span class="mi">1</span>
        <span class="k">print</span> <span class="s">&quot;</span><span class="se">\r</span><span class="s"> </span><span class="si">%d</span><span class="s">/</span><span class="si">%d</span><span class="s"> &quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">bad_count</span><span class="p">,</span> <span class="n">total_count</span><span class="p">),</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">stdout</span><span class="o">.</span><span class="n">flush</span><span class="p">()</span>
    <span class="k">print</span> <span class="s">&#39;&#39;</span>
    <span class="k">return</span> <span class="mi">0</span>
</div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
    <span class="k">except</span> <span class="ne">KeyboardInterrupt</span><span class="p">:</span>
        <span class="k">pass</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>